unit sdl_frame;

interface

uses
   SysUtils, Classes, Controls, ExtCtrls,
   SDL_13;

type
   TSdlFrame = class(TPanel)
   private
      FWindowID: TSdlWindowId;
      FFlags: TSdlWindowFlags;
   protected
      procedure CreateWnd; override;
      procedure DestroyWnd; override;
   public
      property SdlWindow: TSdlWindowId read FWindowID;
   published
      property Flags: TSdlWindowFlags read FFlags write FFlags;
   end;

procedure Register;

implementation
uses forms, SDL;

procedure Register;
begin
  RegisterComponents('SDL', [TSdlFrame]);
end;

{ TSdlFrame }

procedure TSdlFrame.CreateWnd;
begin
   inherited;
   if SDL_WasInit(SDL_INIT_VIDEO) <> SDL_INIT_VIDEO then
      SDL_InitSubSystem(SDL_INIT_VIDEO);
   FWindowID := SDL_CreateWindowFrom(self.Handle);
   assert(SDL_SelectRenderer(FWindowID) = -1);
   assert(SDL_CreateRenderer(FWindowID, 1, [sdlrAccelerated]) = 0);
   SDL_ShowWindow(FWindowID);
   assert(SDL_SetRenderDrawColor(0, 0, 0, 0) = 0);
   assert(SDL_RenderFill(nil) = 0);

   FFlags := SDL_GetWindowFlags(FWindowID);
   Application.MessageBox(PWideChar('SDL_CreateWindowFrom returned: ' + intToHex(FWindowId, 2) + ' and SDL_GetWindowFlags returned ' + intToStr(cardinal(FFlags))), 'Created!');
end;

procedure TSdlFrame.DestroyWnd;
begin
   SDL_DestroyWindow(FWindowID);
   FWindowID := 0;
   inherited;
end;

end.
